import { diff } from 'deep-diff'

function dataHandler (val, oldVal) {
  if (!oldVal) {
    this.renderChart(this.chartData, this.options)
  } else {
    const updateData = val.datasets.some((dataset, i) => {
      if (dataset.data.length !== oldVal.datasets[i].data.length) return true

      const updates = diff(dataset.data, oldVal.datasets[i].data)
      console.log(updates)

      return updates ? updates.length > 0 : false
    })

    const updateLabels = val.labels.length !== oldVal.labels.length || val.labels.some((label, i) => {
      return label !== oldVal.labels[i]
    })

    if (updateData || updateLabels) {
      console.log('updating...')
      this.$data._chart.update()
    }
  }
}

export const reactiveData = {
  data () {
    return {
      chartData: null
    }
  },

  watch: {
    'chartData': {
      handler: dataHandler,
      deep: true
    }
  }
}

export const reactiveProp = {
  props: {
    chartData: {
      required: true
    }
  },
  watch: {
    'chartData': {
      handler: dataHandler,
      deep: true
    }
  }
}

export default {
  reactiveData,
  reactiveProp
}
